\pset null '\\N'

SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(beque)$re$);
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(beque)$re$, '');
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(beque)$re$, 'r');

-- test case insensitive - first variant not possible
SELECT * FROM regexp_matches('foObARbEqUEbAz', $re$(bar)(beque)$re$, 'i');
SELECT * FROM regexp_matches('foObARbEqUEbAz', $re$(bar)(beque)$re$, 'ir');

-- global option - more than one match
SELECT * FROM regexp_matches('foobarbequebazilbarfbonk', $re$(b[^b]+)(b[^b]+)$re$, 'gr');

-- empty capture group (matched empty string)
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(.*)(beque)$re$);
-- no match
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(.+)(beque)$re$);
-- optional capture group did not match, null entry in array
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(.+)?(beque)$re$);

-- nothing before match, empty string
SELECT * FROM regexp_matches('barbequebaz', $re$(bar)(beque)$re$, 'r');
SELECT * FROM regexp_matches('barbequebaz', $re$^(bar)(beque)$re$, 'r');
SELECT * FROM regexp_matches('barbequebaz', $re$(^bar)(beque)$re$, 'r');

-- nothing after match, empty string
SELECT * FROM regexp_matches('foobarbeque', $re$(bar)(beque)$re$, 'r');
SELECT * FROM regexp_matches('foobarbeque', $re$(bar)(beque)$$re$, 'r');
SELECT * FROM regexp_matches('foobarbeque', $re$(bar)(beque$)$re$, 'r');

-- no capture groups, should first throw error?
SELECT * FROM regexp_matches('foobarbequebaz', $re$barbeque$re$);
SELECT * FROM regexp_matches('foobarbequebaz', $re$barbeque$re$, '');
SELECT * FROM regexp_matches('foobarbequebaz', $re$barbeque$re$, 'r');

-- give me errors
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(beque)$re$, 'zipper');
SELECT * FROM regexp_matches('foobarbequebaz', $re$(barbeque$re$, '');
SELECT * FROM regexp_matches('foobarbequebaz', $re$(bar)(beque){2,1}$re$, '');


-- vim: set ft=psql :
